/*
    Look at the assembly language listing to see
    how the addition expressions given below
    are compiled into different chunks of code.
    Look for the implicit casting (promotion) that
    is being done by the compiler.
*/
#include <stdio.h>

int main()
{
   int x = 1;
   int y = 2;
   double u = 3.0;
   double v = 4.0;

   x = x + y;  // int + int
   u = x + y;  // int + int -> double
   u = x + u;  // int + double
   u = u + v;  // double + double

   return 0;
}